
#include "coordinate3D.h"
#include "genericList.c"

#include <math.h>

int main (int argc, char** argv) {

  GenericList<Coordinate3D*>* list = new GenericList<Coordinate3D*>();

  list->push(new Coordinate3D(1.0,0.0,1.0));
  list->push(new Coordinate3D(1.0,0.0,1.0));
  list->push(new Coordinate3D(1.0,0.0,1.0));
  list->push(new Coordinate3D(1.0,0.0,1.0));
  list->push(new Coordinate3D(1.0,0.0,1.0));
  list->push(new Coordinate3D(1.0,0.0,1.0));
  list->push(new Coordinate3D(1.0,0.0,1.0));
  list->push(new Coordinate3D(1.0,0.0,1.0));
  
  int i = 0;
  Coordinate3D* coord = list->getFirst();
  for (i=0; i<list->getLength(); i++) {
    printf("%d: (%3.2f,%3.2f,%3.2f)\n",i,coord->getX(),coord->getY(),coord->getZ());
    coord = list->getNext();
  }

  float pi = 4.0*atan(1.0);
  printf("pi = %3.8f\n",pi);
  coord = list->getFirst();
  for (i=0; i<list->getLength(); i++) {
    coord->rotateZ(pi * ((float)i / 4.0));
    printf("%d: (%3.2f,%3.2f,%3.2f)\n",i,coord->getX(),coord->getY(),coord->getZ());
    coord = list->getNext();
  }

  return 1;
}
